pcl::LocalMaximum< PointT > Class Template Reference
Module filters

LocalMaximum downsamples the cloud, by eliminating points that are locally maximal. More...

`#include <pcl/filters/local_maximum.h>`

Inheritance diagram for pcl::LocalMaximum< PointT >:

## Public Member Functions

| LocalMaximum (bool extract_removed_indices=false)
| Empty constructor. More...
void | setRadius (float radius)
| Set the radius to use to determine if a point is the local max. More...
float | getRadius () const
| Get the radius to use to determine if a point is the local max. More...
Public Member Functions inherited from pcl::FilterIndices< PointT >
| FilterIndices (bool extract_removed_indices=false)
| Constructor. More...
| ~FilterIndices ()
| Empty virtual destructor. More...
void | filter (PointCloud &output)
void | filter (std::vector< int > &indices)
| Calls the filtering method and returns the filtered point cloud indices. More...
void | setNegative (bool negative)
| Set whether the regular conditions for points filtering should apply, or the inverted conditions. More...
bool | getNegative () const
| Get whether the regular conditions for points filtering should apply, or the inverted conditions. More...
void | setKeepOrganized (bool keep_organized)
| Set whether the filtered points should be kept and set to the value given through setUserFilterValue (default: NaN), or removed from the PointCloud, thus potentially breaking its organized structure. More...
bool | getKeepOrganized () const
| Get whether the filtered points should be kept and set to the value given through setUserFilterValue (default = NaN), or removed from the PointCloud, thus potentially breaking its organized structure. More...
void | setUserFilterValue (float value)
| Provide a value that the filtered points should be set to instead of removing them. More...
Public Member Functions inherited from pcl::Filter< PointT >
| Filter (bool extract_removed_indices=false)
| Empty constructor. More...
| ~Filter ()
| Empty destructor. More...
const IndicesConstPtr | getRemovedIndices () const
| Get the point indices being removed. More...
void | getRemovedIndices (PointIndices &pi)
| Get the point indices being removed. More...
void | filter (PointCloud &output)
| Calls the filtering method and returns the filtered dataset in output. More...
Public Member Functions inherited from pcl::PCLBase< PointT >
| PCLBase ()
| Empty constructor. More...
| PCLBase (const PCLBase &base)
| Copy constructor. More...
virtual | ~PCLBase ()
| Destructor. More...
virtual void | setInputCloud (const PointCloudConstPtr &cloud)
| Provide a pointer to the input dataset. More...
const PointCloudConstPtr | getInputCloud () const
| Get a pointer to the input point cloud dataset. More...
virtual void | setIndices (const IndicesPtr &indices)
| Provide a pointer to the vector of indices that represents the input data. More...
virtual void | setIndices (const IndicesConstPtr &indices)
| Provide a pointer to the vector of indices that represents the input data. More...
virtual void | setIndices (const PointIndicesConstPtr &indices)
| Provide a pointer to the vector of indices that represents the input data. More...
virtual void | setIndices (std::size_t row_start, std::size_t col_start, std::size_t nb_rows, std::size_t nb_cols)
| Set the indices for the points laying within an interest region of the point cloud. More...
const IndicesPtr | getIndices ()
| Get a pointer to the vector of indices used. More...
const IndicesConstPtr | getIndices () const
| Get a pointer to the vector of indices used. More...
const PointT & | operator[] (std::size_t pos) const
| Override PointCloud operator[] to shorten code. More...

## Protected Types

using | PointCloud = typename FilterIndices< PointT >::PointCloud
using | SearcherPtr = typename pcl::search::Search< PointT >::Ptr

## Protected Member Functions

void | applyFilter (PointCloud &output) override
| Downsample a Point Cloud by eliminating points that are locally maximal in z. More...
void | applyFilter (std::vector< int > &indices) override
| Filtered results are indexed by an indices array. More...
void | applyFilterIndices (std::vector< int > &indices)
| Filtered results are indexed by an indices array. More...
Protected Member Functions inherited from pcl::Filter< PointT >
const std::string & | getClassName () const
| Get a string representation of the name of this class. More...
Protected Member Functions inherited from pcl::PCLBase< PointT >
bool | initCompute ()
| This method should get called before starting the actual computation. More...
bool | deinitCompute ()
| This method should get called after finishing the actual computation. More...

## Additional Inherited Members

Public Types inherited from pcl::FilterIndices< PointT >
using | PointCloud = pcl::PointCloud< PointT >
using | Ptr = shared_ptr< FilterIndices< PointT > >
using | ConstPtr = shared_ptr< const FilterIndices< PointT > >
Public Types inherited from pcl::Filter< PointT >
using | Ptr = shared_ptr< Filter< PointT > >
using | ConstPtr = shared_ptr< const Filter< PointT > >
using | PointCloud = pcl::PointCloud< PointT >
using | PointCloudPtr = typename PointCloud::Ptr
using | PointCloudConstPtr = typename PointCloud::ConstPtr
Public Types inherited from pcl::PCLBase< PointT >
using | PointCloud = pcl::PointCloud< PointT >
using | PointCloudPtr = typename PointCloud::Ptr
using | PointCloudConstPtr = typename PointCloud::ConstPtr
using | PointIndicesPtr = PointIndices::Ptr
using | PointIndicesConstPtr = PointIndices::ConstPtr
Protected Attributes inherited from pcl::FilterIndices< PointT >
bool | negative_
| False = normal filter behavior (default), true = inverted behavior. More...
bool | keep_organized_
| False = remove points (default), true = redefine points, keep structure. More...
float | user_filter_value_
| The user given value that the filtered point dimensions should be set to (default = NaN). More...
Protected Attributes inherited from pcl::Filter< PointT >
IndicesPtr | removed_indices_
| Indices of the points that are removed. More...
std::string | filter_name_
| The filter name. More...
bool | extract_removed_indices_
| Set to true if we want to return the indices of the removed points. More...
Protected Attributes inherited from pcl::PCLBase< PointT >
PointCloudConstPtr | input_
| The input point cloud dataset. More...
IndicesPtr | indices_
| A pointer to the vector of point indices to use. More...
bool | use_indices_
| Set to true if point indices are used. More...
bool | fake_indices_
| If no set of indices are given, we construct a set of fake indices that mimic the input PointCloud. More...

## Detailed Description

### template<typename PointT>
class pcl::LocalMaximum< PointT >

LocalMaximum downsamples the cloud, by eliminating points that are locally maximal.

The LocalMaximum class analyzes each point and removes those that are found to be locally maximal with respect to their neighbors (found via radius search). The comparison is made in the z dimension only at this time.

Author
  Bradley J Chambers

Definition at line 60 of file local_maximum.h.

## Member Typedef Documentation

## PointCloud

template<typename PointT >

using pcl::LocalMaximum< PointT >::PointCloud = typename FilterIndices<PointT>::PointCloud

protected

Definition at line 63 of file local_maximum.h.

## SearcherPtr

template<typename PointT >

using pcl::LocalMaximum< PointT >::SearcherPtr = typename pcl::search::Search<PointT>::Ptr

protected

Definition at line 64 of file local_maximum.h.

## Constructor & Destructor Documentation

## LocalMaximum()

template<typename PointT >

pcl::LocalMaximum< PointT >::LocalMaximum | ( | bool | extract_removed_indices = `false` | ) |

inline

Empty constructor.

Definition at line 68 of file local_maximum.h.

References pcl::Filter< PointT >::filter_name_.

## Member Function Documentation

## applyFilter() [1/2]

template<typename PointT >

void pcl::LocalMaximum< PointT >::applyFilter | ( | PointCloud & | output | ) |

override protected virtual

Downsample a Point Cloud by eliminating points that are locally maximal in z.

Parameters

  [out] | output | the resultant point cloud message

Implements pcl::FilterIndices< PointT >.

Definition at line 52 of file local_maximum.hpp.

References pcl::PointCloud< PointT >::height, pcl::PointCloud< PointT >::is_dense, pcl::PointCloud< PointT >::points, and pcl::PointCloud< PointT >::width.

## applyFilter() [2/2]

template<typename PointT >

void pcl::LocalMaximum< PointT >::applyFilter | ( | std::vector< int > & | indices | ) |

inline override protected virtual

Filtered results are indexed by an indices array.

Parameters

  [out] | indices | The resultant indices.

Implements pcl::FilterIndices< PointT >.

Definition at line 107 of file local_maximum.h.

References pcl::LocalMaximum< PointT >::applyFilterIndices().

## applyFilterIndices()

template<typename PointT >

void pcl::LocalMaximum< PointT >::applyFilterIndices | ( | std::vector< int > & | indices | ) |

protected

Filtered results are indexed by an indices array.

Parameters

  [out] | indices | The resultant indices.

Definition at line 72 of file local_maximum.hpp.

References pcl::Filter< PointT >::filter(), pcl::isFinite(), pcl::SACMODEL_PLANE, pcl::PCLBase< PointT >::setInputCloud(), pcl::ProjectInliers< PointT >::setModelCoefficients(), and pcl::ProjectInliers< PointT >::setModelType().

Referenced by pcl::LocalMaximum< PointT >::applyFilter().

## getRadius()

template<typename PointT >

float pcl::LocalMaximum< PointT >::getRadius | ( |  | ) | const

inline

Get the radius to use to determine if a point is the local max.

Returns
  The radius to use to determine if a point is the local max.

Definition at line 86 of file local_maximum.h.

## setRadius()

template<typename PointT >

void pcl::LocalMaximum< PointT >::setRadius | ( | float | radius | ) |

inline

Set the radius to use to determine if a point is the local max.

Parameters

  [in] | radius | The radius to use to determine if a point is the local max.

Definition at line 80 of file local_maximum.h.

The documentation for this class was generated from the following files:

- pcl/filters/local_maximum.h
- pcl/filters/impl/local_maximum.hpp